# lrs_ardupilot

WIH THE INSTRUCTIONS BELOW TAKE-OFF FAILS IN SIMULATION!

WILL BE FIXED SOONISH...

## 1. Background

- Ardupilot simulator: https://hub.docker.com/r/radarku/ardupilot-sitl
- QGroundControl documentation: https://docs.qgroundcontrol.com/master/en/getting_started/quick_start.html
- Mavproxy: https://hub.docker.com/r/asciich/mavproxy
- Mavproxy source: https://pypi.org/project/MAVProxy/
- DroneKit: https://dronekit-python.readthedocs.io/en/latest/about/index.html
- PyMavlink: https://github.com/ArduPilot/pymavlink
- ArduSub: https://www.ardusub.com/
- Mutable Mapping Issue: https://stackoverflow.com/questions/70943244/attributeerror-module-collections-has-no-attribute-mutablemapping

## 2. Installation

### 2.1 LRS Ros Packages

For how to install the public repositories needed see: https://gitlab.liu.se/lrs2/lrs_doc/-/blob/main/README.md

### 2.2 QGroundControl

How to install: https://docs.qgroundcontrol.com/master/en/getting_started/download_and_install.html

### 2.3 DroneKit

Install:
```bash
cd
mkdir ardu
cd ardu
virtualenv --system-site-packages venv
source venv/bin/activate
pip install dronekit
pip install dronekit-sitl
pip install mavproxy
```
Need patch for Python 3.10 when using it:

```python
import collections.abc
import collections
collections.MutableMapping = collections.abc.MutableMapping
```
## 3. Test Example using QGroundControl as Display

Set LRS_LOCATION to granso:
```bash
export LRS_LOCATION=granso
```

### 3.1 Start Simulation and QGroundControl Visualization

Start simulator Copter:
```bash
source ardu/venv/bin/activate
dronekit-sitl copter --home 57.7605573519,16.6827607783,1.9,0.0 --model X --speedup 1.0
```

Mavproxy:
```bash
source ardu/venv/bin/activate
mavproxy.py --master=tcp:127.0.0.1:5760 --out udp:127.0.0.1:14550 --out tcpin:127.0.0.1:14551 --out tcpin:127.0.0.1:14552
```

QGroundControl as default connect to UDP on 14550. Just start QGroundControl:
```bash
./QGroundControl.AppImage
```

### 3.2 Start TST Executor

#### 3.2.1 Start using ONE launchfil + One ROSRUN...

```bash
ros2 launch lrs_ardupilot ardupilot.launch.py ns:=/ardu0 name:=ardu0 show_tst:=true
```

Start in venv:
```bash
source ardu/venv/bin/activate
cd `ros2 pkg prefix lrs_ardupilot`
cd lib/lrs_ardupilot
python ardu_manager --ros-args -r __ns:=/ardu0 -p port:=14552
```

#### 3.2.2 Start using TMUX

Start for copter control:
```bash
cd lrs_ardupilot/src
python ardupilot_tmux.py -a
```

#### 3.2.3 Start Manually

Start manually for copter control.

Start common programs and the basic executors:
```bash
ros2 launch lrs_exec exec.launch.py location:=granso ns:=/ardu0 basic_executors:=true
```
Start TST streamer:
```bash
ros2 launch lrs_exec tst_streamer.launch.py ns:=/ardu0 display_type:=exec name:=tst_streamer_exex
```

View TST stream:
```bash
ros2 run rqt_image_view rqt_image_view /ardu0/tststream_exec/image_raw/compressed
```

Start ROS2 program that interfaces to the ardupilot:
```bash
ros2 run lrs_ardupilot ardupilot --ros-args -r __ns:=/ardu0
```

## 4.1 Testing

```bash
ros2 run lrs_exec tst_command --ros-args -r __ns:=/ardu0 -p command:=take-off
```

```bash
ros2 run lrs_exec tst_command --ros-args -r __ns:=/ardu0 -p command:=land
```

```bash
ros2 run lrs_exec tst_command --ros-args -r __ns:=/ardu0 -p command:=in-air-goal
```

```bash
ros2 run lrs_exec tst_command --ros-args -r __ns:=/ardu0 -p command:=fly -p x:=10.0 -p y:=10.0 -p z:=20.0 -p speed:=4.0
```

```bash
ros2 run lrs_exec tst_command --ros-args -r __ns:=/ardu0 -p command:=move -p x:=110.0 -p y:=10.0 -p z:=20.0 -p speed:=4.0
```

