import rclpy

from lrs_exec.executor_factory import ExecutorFactory
from lrs_util.jsonutil import *

class GoHomeExecutorFactory(ExecutorFactory):
    def __init__(self):
        super().__init__("go-home", expandable=True)

    def json_expand(self, node_json):
        # self.get_logger().error(f'json_expand node_json: {node_json}')        
        res = ""
        if not self.expandable:
            return res
        try:
            # self.get_logger().error(f'json_expand node_json: {node_json}')
            jobj = json.loads(node_json)
            # self.get_logger().error(f'json_expand OBJ: {jobj}')
            # self.get_logger().error(f"json_expand: {json.dumps(jobj, sort_keys=True, indent=4, separators=(',', ': '))}")
            name = get_name(jobj)

            # self.get_logger().error(f'json_expand name: {name}')            

            exec_unit = get_exec_unit(jobj)
            
            seqobj = json_basic_seq(exec_unit)
            seqobj["children"].append(json_basic_return_home(exec_unit))
            seqobj["children"].append(json_basic_land(exec_unit))

            res = json.dumps(seqobj, sort_keys=True, indent=4, separators=(',', ': '))
        except Exception as exc:
            self.get_logger().error(f'EXCEPTION return_home json_expand: {type(exc)} - {exc}')            
        return res
