import rclpy

from lrs_exec.executor_factory import ExecutorFactory
from lrs_msgs_tst.msg import TSTNodeStatus

from lrs_util.jsonutil import *

class InAirGoalExecutorFactory(ExecutorFactory):
    def __init__(self):
        super().__init__("in-air-goal", expandable=True)
        
    def json_expand(self, node_json):
        res = ""
        if not self.expandable:
            return res
        try:
            jobj = json.loads(node_json)
            name = get_name(jobj)
                    
            exec_unit = get_exec_unit(jobj)
        
            expobj = json_basic_test_if(exec_unit)
            expobj["children"].append(json_basic_in_air_test(exec_unit))
            expobj["children"].append(json_basic_noop(exec_unit))
            expobj["children"].append(json_basic_take_off(exec_unit))
            expobj["children"].append(json_basic_noop(exec_unit))
            res = json.dumps(expobj, sort_keys=True, indent=4, separators=(',', ': '))
        except Exception as exc:
            self.get_logger().error(f'EXCEPTION expand: {type(exc)} - {exc}')
        return res
