import rclpy

from lrs_exec.executor_factory import ExecutorFactory
from lrs_msgs_tst.msg import TSTNodeStatus

from lrs_util.jsonutil import *

class MoveToExecutorFactory(ExecutorFactory):
    def __init__(self):
        super().__init__("move-to", expandable=True)
        
    def json_expand(self, node_json):
        # self.get_logger().error(f'json_expand node_json: {node_json}')        
        res = ""
        if not self.expandable:
            return res
        try:
            # self.get_logger().error(f'json_expand node_json: {node_json}')
            jobj = json.loads(node_json)
            # self.get_logger().error(f'json_expand OBJ: {jobj}')
            self.get_logger().error(f"json_expand: {json.dumps(jobj, sort_keys=True, indent=4, separators=(',', ': '))}")
            name = get_name(jobj)

            self.get_logger().error(f'json_expand name: {name}')            
                    
            exec_unit = get_exec_unit(jobj)
            self.get_logger().error(f'expand_move_to EXECUTION UNIT: {exec_unit}')
            
            wp = jobj["params"]["waypoint"]
            self.get_logger().error(f'expand_move_to wp: {wp}')
            
            flyto = json_basic_flyto(exec_unit, 0.0, 0.0, 0.0, -1.0, speed=jobj["params"]["speed"], geopoint=wp)

            seqobj = json_basic_seq(exec_unit)
            seqobj["children"].append(json_basic_in_air_goal(exec_unit))
            seqobj["children"].append(flyto)
                
            res = json.dumps(seqobj, sort_keys=True, indent=4, separators=(',', ': '))
        except Exception as exc:
            self.get_logger().error(f'EXCEPTION move_to json_expand: {type(exc)} - {exc}')            
        return res
    
