import serial, time

from pynmeagps import NMEAMessage, GET

SERIALPORT = "/dev/ttyUSB0"
BAUDRATE = 57600

def decimal_to_nmea(coord, is_latitude=True):
    """
    Convert a decimal degree coordinate to NMEA format.
    """
    degrees = int(coord)
    minutes = abs(coord - degrees) * 60
    nmea_coord = f"{abs(degrees):02d}{minutes:07.4f}"
    direction = ""
 
    if is_latitude:
        direction = "N" if coord >= 0 else "S"
    else:
        nmea_coord = f"{abs(degrees):03d}{minutes:07.4f}"
        direction = "E" if coord >= 0 else "W"
 
    return nmea_coord, direction


# ser = serial.Serial(port=SERIALPORT, baudrate=BAUDRATE, bytesize=8, parity='N', stopbits=1)  # open serial port
# print(ser.name)         # check which port was really used

lat = 57.7605573519
lon = 16.6827607783
alt = 27.9

nlat = decimal_to_nmea(lat, True)
nlon = decimal_to_nmea(lon, False)

print(nlat, nlon)

payload=["172814.0",nlat[0],nlat[1],nlon[0],nlon[1],
         "4","24","0.5","18.893","M","-25.669","M", "", ""]

msg = NMEAMessage('GP','GGA', GET, payload=payload)
print(msg)
print("TIME:", msg.time, type(msg.time))
print(msg.serialize())


#ser.write(msg.serialize())     # write a string
#ser.close()             # close port
