import os
from glob import glob

from setuptools import setup

package_name = 'lrs_ardupilot'

setup(
    name=package_name,
    version='0.0.0',
    packages=[package_name, f'{package_name}/executors'],
    data_files=[
        ('share/ament_index/resource_index/packages',
            ['resource/' + package_name]),
        ('share/' + package_name, ['package.xml']),
        (os.path.join('share', package_name) + "/script", ['src/start_tst_rtmp.sh']),
        (os.path.join('share', package_name), glob('launch/*.launch.py')),
    ],
    install_requires=['setuptools'],
    zip_safe=True,
    maintainer='tompe',
    maintainer_email='tommy.persson@liu.se',
    description='TODO: Package description',
    license='TODO: License declaration',
    tests_require=['pytest'],
    entry_points={
        'console_scripts': [
            'ardu_manager = lrs_ardupilot.ardu_manager:main',            
            'ardu_command = lrs_ardupilot.ardu_command:main',            
            'ardupilot_connect = lrs_ardupilot.ardupilot_connect:main',
            'exec_ardupilot_executors = lrs_ardupilot.exec_ardupilot_executors:main',                        
        ],
    },
)
