#!/usr/bin/env python3

from os import system, environ
import time
import sys
import os

from tmux import *

from optparse import OptionParser

parser = OptionParser()
parser.add_option ("-a", "--attach", action="store_true", dest="attach", help="Attach")
parser.add_option ("", "--ns", action="store", type="string", dest="ns", default="/ardu0", help="Namespace to use (default /ardu0)")
parser.add_option ("", "--location", action="store", type="string", dest="location", default="granso", help="Location to use")
(options, args) = parser.parse_args()

def main_unit(ns):
    command = f"new-session -n roscore -d -s {ns} 'exec bash'"
    print("main_unit command:", command)    
    tmux(command)
    # tmux new-session 'export MY_VAR=value; exec bash'

    #    tmux("rename-window roscore")
    
    #command = f'setenv ROS_MASTER_URI {get_rmu()}'
    #print("main_unit command:", command)    
    #tmux(command)

    #tmux_shell("roscore")

    new_window("common_exec", f'ros2run', run=True)
    tmux_shell(f'ros2 launch lrs_exec exec.launch.py location:={options.location} ns:={ns} basic_executors:=true')

    new_window("tst_exec_streamer", f'ros2run', run=True)
    tmux_shell(f"ros2 launch lrs_exec tst_streamer.launch.py ns:={ns} display_type:=exec name:=tst_streamer_exex")

    time.sleep(2)
    new_window("view_tst", f'ros2run', run=True)
    tmux_shell(f'ros2 run rqt_image_view rqt_image_view {ns}/tststream_exec/image_raw/compressed')
    
    new_window("ardupilot", f'ros2run', run=True)
    tmux_shell(f'ros2 run lrs_ardupilot ardupilot --ros-args -r __ns:={ns}')

    if options.attach:
        tmux(f'attach-session -t {options.ns}')
    



if __name__ == "__main__":
    ns = options.ns

    main_unit(ns)    
